Whamcloud - gitweb
LU-1347 build: remove the vim/emacs modelines
[fs/lustre-release.git] / lustre / tests / replay-ost-single.sh
1 #!/bin/bash
2 # -*- mode: Bash; tab-width: 4; indent-tabs-mode: t; -*-
3 # vim:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 set -e
6
7 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
8 SETUP=${SETUP:-""}
9 CLEANUP=${CLEANUP:-""}
10 . $LUSTRE/tests/test-framework.sh
11 init_test_env $@
12 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
13 init_logging
14
15 # While we do not use OSTCOUNT=1 setup anymore,
16 # ost1failover_HOST is used
17 #ostfailover_HOST=${ostfailover_HOST:-$ost_HOST}
18 #failover= must be defined in OST_MKFS_OPTIONS if ostfailover_HOST != ost_HOST
19
20 require_dsh_ost || exit 0
21
22 # Tests that fail on uml
23 CPU=`awk '/model/ {print $4}' /proc/cpuinfo`
24 [ "$CPU" = "UML" ] && EXCEPT="$EXCEPT 6"
25
26 # Skip these tests
27 # BUG NUMBER: 
28 ALWAYS_EXCEPT="$REPLAY_OST_SINGLE_EXCEPT"
29
30 #                                       
31 [ "$SLOW" = "no" ] && EXCEPT_SLOW="5"
32
33 build_test_filter
34
35 check_and_setup_lustre
36 assert_DIR
37 rm -rf $DIR/[df][0-9]*
38
39 TDIR=$DIR/d0.${TESTSUITE}
40 mkdir -p $TDIR
41 $LFS setstripe $TDIR -i 0 -c 1
42 $LFS getstripe $TDIR
43
44 test_0a() {
45     zconf_umount `hostname` $MOUNT -f
46     # needs to run during initial client->OST connection
47     #define OBD_FAIL_OST_ALL_REPLY_NET       0x211
48     do_facet ost1 "lctl set_param fail_loc=0x80000211"
49     zconf_mount `hostname` $MOUNT && df $MOUNT || error "0a mount fail"
50 }
51 run_test 0a "target handle mismatch (bug 5317) `date +%H:%M:%S`"
52
53 test_0b() {
54     fail ost1
55     cp /etc/profile  $TDIR/$tfile
56     sync
57     diff /etc/profile $TDIR/$tfile
58     rm -f $TDIR/$tfile
59 }
60 run_test 0b "empty replay"
61
62 test_1() {
63     date > $TDIR/$tfile || error "error creating $TDIR/$tfile"
64     fail ost1
65     $CHECKSTAT -t file $TDIR/$tfile || return 1
66     rm -f $TDIR/$tfile
67 }
68 run_test 1 "touch"
69
70 test_2() {
71     for i in `seq 10`; do
72         echo "tag-$i" > $TDIR/$tfile-$i || error "create $TDIR/$tfile-$i"
73     done 
74     fail ost1
75     for i in `seq 10`; do
76       grep -q "tag-$i" $TDIR/$tfile-$i || error "grep $TDIR/$tfile-$i"
77     done 
78     rm -f $TDIR/$tfile-*
79 }
80 run_test 2 "|x| 10 open(O_CREAT)s"
81
82 test_3() {
83     verify=$ROOT/tmp/verify-$$
84     dd if=/dev/urandom bs=4096 count=1280 | tee $verify > $TDIR/$tfile &
85     ddpid=$!
86     sync &
87     fail ost1
88     wait $ddpid || return 1
89     cmp $verify $TDIR/$tfile || return 2
90     rm -f $verify $TDIR/$tfile
91 }
92 run_test 3 "Fail OST during write, with verification"
93
94 test_4() {
95     verify=$ROOT/tmp/verify-$$
96     dd if=/dev/urandom bs=4096 count=1280 | tee $verify > $TDIR/$tfile
97     # invalidate cache, so that we're reading over the wire
98     cancel_lru_locks osc
99     cmp $verify $TDIR/$tfile &
100     cmppid=$!
101     fail ost1
102     wait $cmppid || return 1
103     rm -f $verify $TDIR/$tfile
104 }
105 run_test 4 "Fail OST during read, with verification"
106
107 iozone_bg () {
108     local args=$@
109
110     local tmppipe=$TMP/${TESTSUITE}.${TESTNAME}.pipe
111     mkfifo $tmppipe
112
113     echo "+ iozone $args"
114     iozone $args > $tmppipe &
115
116     local pid=$!
117
118     echo "tmppipe=$tmppipe"
119     echo iozone pid=$pid
120
121     # iozone exit code is 0 even if iozone is not completed
122     # need to check iozone output  on "complete"
123     local iozonelog=$TMP/${TESTSUITE}.iozone.log
124     rm -f $iozonelog
125     cat $tmppipe | while read line ; do
126         echo "$line"
127         echo "$line" >>$iozonelog
128     done;
129
130     local rc=0
131     wait $pid
132     rc=$?
133     if ! $(tail -1 $iozonelog | grep -q complete); then
134         echo iozone failed!
135         rc=1
136     fi
137     rm -f $tmppipe
138     rm -f $iozonelog
139     return $rc
140 }
141
142 test_5() {
143     [ -z "`which iozone 2> /dev/null`" ] && skip_env "iozone missing" && return 0
144
145     # striping is -c 1, get min of available
146     local minavail=$(lctl get_param -n osc.*[oO][sS][cC][-_]*.kbytesavail | sort -n | head -1)
147     local size=$(( minavail * 3/4 ))
148     local GB=1048576  # 1048576KB == 1GB
149
150     if (( size > GB )); then
151         size=$GB
152     fi
153     local iozone_opts="-i 0 -i 1 -i 2 -+d -r 4 -s $size -f $TDIR/$tfile"
154
155     iozone_bg $iozone_opts &
156     local pid=$!
157
158     echo iozone bg pid=$pid
159
160     sleep 8
161     fail ost1
162     local rc=0
163     wait $pid
164     rc=$?
165     log "iozone rc=$rc"
166     rm -f $TDIR/$tfile
167     [ $rc -eq 0 ] || error "iozone failed"
168     return $rc
169 }
170 run_test 5 "Fail OST during iozone"
171
172 kbytesfree() {
173    calc_osc_kbytes kbytesfree
174 }
175
176 test_6() {
177     remote_mds_nodsh && skip "remote MDS with nodsh" && return 0
178
179     f=$TDIR/$tfile
180     rm -f $f
181     sync && sleep 2 && sync  # wait for delete thread
182
183     # wait till space is returned, following
184     # (( $before > $after_dd)) test counting on that
185     wait_mds_ost_sync || return 4
186     wait_destroy_complete || return 5
187
188     before=`kbytesfree`
189     dd if=/dev/urandom bs=4096 count=1280 of=$f || return 28
190     lfs getstripe $f
191     stripe_index=$(lfs getstripe -i $f)
192
193     sync
194     sleep 2 # ensure we have a fresh statfs
195     sync
196
197     #define OBD_FAIL_MDS_REINT_NET_REP       0x119
198     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
199     after_dd=`kbytesfree`
200     log "before: $before after_dd: $after_dd"
201     (( $before > $after_dd )) || return 1
202     rm -f $f
203     fail ost$((stripe_index + 1))
204     wait_recovery_complete ost$((stripe_index + 1)) ||
205         error "OST$((stripe_index + 1)) recovery not completed"
206     $CHECKSTAT -t file $f && return 2 || true
207     sync
208     # let the delete happen
209     wait_mds_ost_sync || return 4
210     wait_destroy_complete || return 5
211     after=`kbytesfree`
212     log "before: $before after: $after"
213     (( $before <= $after + 40 )) || return 3   # take OST logs into account
214 }
215 run_test 6 "Fail OST before obd_destroy"
216
217 test_7() {
218     f=$TDIR/$tfile
219     rm -f $f
220     sync && sleep 5 && sync     # wait for delete thread
221
222     # wait till space is returned, following
223     # (( $before > $after_dd)) test counting on that
224     wait_mds_ost_sync || return 4
225     wait_destroy_complete || return 5
226
227     before=`kbytesfree`
228     dd if=/dev/urandom bs=4096 count=1280 of=$f || return 4
229     sync
230     sleep 2 # ensure we have a fresh statfs
231     sync
232     after_dd=`kbytesfree`
233     log "before: $before after_dd: $after_dd"
234     (( $before > $after_dd )) || return 1
235     replay_barrier ost1
236     rm -f $f
237     fail ost1
238     wait_recovery_complete ost1 || error "OST recovery not done"
239     $CHECKSTAT -t file $f && return 2 || true
240     sync
241     # let the delete happen
242     wait_mds_ost_sync || return 4
243     wait_destroy_complete || return 5
244     after=`kbytesfree`
245     log "before: $before after: $after"
246     (( $before <= $after + 40 )) || return 3    # take OST logs into account
247 }
248 run_test 7 "Fail OST before obd_destroy"
249
250 test_8a() {
251     verify=$ROOT/tmp/verify-$$
252     dd if=/dev/urandom of=$verify bs=4096 count=1280 ||
253         error "Create verify file failed"
254 #define OBD_FAIL_OST_DQACQ_NET           0x230
255     do_facet ost1 "lctl set_param fail_loc=0x230"
256     dd if=$verify of=$TDIR/$tfile bs=4096 count=1280 oflag=sync &
257     ddpid=$!
258     sleep $TIMEOUT  # wait for the io to become redo io
259     if ! ps -p $ddpid  > /dev/null 2>&1; then
260             error "redo io finished incorrectly"
261             return 1
262     fi
263     do_facet ost1 "lctl set_param fail_loc=0"
264     wait $ddpid || return 1
265     cancel_lru_locks osc
266     cmp $verify $TDIR/$tfile || return 2
267     rm -f $verify $TDIR/$tfile
268 }
269 run_test 8a "Verify redo io: redo io when get -EINPROGRESS error"
270
271 test_8b() {
272     verify=$ROOT/tmp/verify-$$
273     dd if=/dev/urandom of=$verify bs=4096 count=1280 ||
274         error "Create verify file failed"
275 #define OBD_FAIL_OST_DQACQ_NET           0x230
276     do_facet ost1 "lctl set_param fail_loc=0x230"
277     dd if=$verify of=$TDIR/$tfile bs=4096 count=1280 oflag=sync &
278     ddpid=$!
279     sleep $TIMEOUT  # wait for the io to become redo io
280     fail ost1
281     do_facet ost1 "lctl set_param fail_loc=0"
282     wait $ddpid || return 1
283     cancel_lru_locks osc
284     cmp $verify $TDIR/$tfile || return 2
285     rm -f $verify $TDIR/$tfile
286 }
287 run_test 8b "Verify redo io: redo io should success after recovery"
288
289 test_8c() {
290     verify=$ROOT/tmp/verify-$$
291     dd if=/dev/urandom of=$verify bs=4096 count=1280 ||
292         error "Create verify file failed"
293 #define OBD_FAIL_OST_DQACQ_NET           0x230
294     do_facet ost1 "lctl set_param fail_loc=0x230"
295     dd if=$verify of=$TDIR/$tfile bs=4096 count=1280 oflag=sync &
296     ddpid=$!
297     sleep $TIMEOUT  # wait for the io to become redo io
298     ost_evict_client
299     # allow recovery to complete
300     sleep $((TIMEOUT + 2))
301     do_facet ost1 "lctl set_param fail_loc=0"
302     wait $ddpid
303     cancel_lru_locks osc
304     cmp $verify $TDIR/$tfile && return 2
305     rm -f $verify $TDIR/$tfile
306 }
307 run_test 8c "Verify redo io: redo io should fail after eviction"
308
309
310 test_9d() {
311 #define OBD_FAIL_MDS_DQACQ_NET           0x187
312     do_facet $SINGLEMDS "lctl set_param fail_loc=0x187"
313     # test the non-intent create path
314     mcreate $TDIR/$tfile &
315     cpid=$!
316     sleep $TIMEOUT
317     if ! ps -p $cpid  > /dev/null 2>&1; then
318             error "mknod finished incorrectly"
319             return 1
320     fi
321     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
322     wait $cpid || return 2
323     stat $TDIR/$tfile || error "mknod failed"
324
325     rm $TDIR/$tfile
326
327 #define OBD_FAIL_MDS_DQACQ_NET           0x187
328     do_facet $SINGLEMDS "lctl set_param fail_loc=0x187"
329     # test the intent create path
330     openfile -f O_RDWR:O_CREAT $TDIR/$tfile &
331     cpid=$!
332     sleep $TIMEOUT
333     if ! ps -p $cpid > /dev/null 2>&1; then
334             error "open finished incorrectly"
335             return 3
336     fi
337     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
338     wait $cpid || return 4
339     stat $TDIR/$tfile || error "open failed"
340 }
341 run_test 9d "Verify redo creation on -EINPROGRESS"
342
343 complete $(basename $0) $SECONDS
344 check_and_cleanup_lustre
345 exit_status